import os

def f_combineINP(inp_file = None, working_dir = '/.', result_name = None):
    '''
    Reads in an .inp file, searches for 
    *INCLUDE statements and combines all
    files to one new inp. file
    (..._comb.inp).

    Parameters:
    - inp_file (string):
        inp. file to combine.
    - working_dir (string):
        Working directory to execute file in.

    Returns:
    - None
    '''
    
    # open input file
    with open(os.path.join(working_dir, inp_file),'r') as input_file:
        input_lines = input_file.readlines()

    # find *INCLUDE lines and according file names
    # [line_idx, include_file_name]
    include_information = []
    for i,line in enumerate(input_lines):
        if line.find('*INCLUDE') != -1:
            include_information.append([i, line.split(',')[-1].strip(' ').strip('INPUT=').strip('\n')])
    
    # combine all files to one new file
    combined_lines = []
    for i,line in enumerate(input_lines):
        line_ids = [x[0] for x in include_information]
        if i in line_ids:
            # open include file
            with open(os.path.join(working_dir, include_information[line_ids.index(i)][1]),'r') as include_file:
                include_lines = include_file.readlines()
            for include_line in include_lines:
                combined_lines.append(include_line)
            combined_lines.append('\n')
        else:
            combined_lines.append(line)

    # write combined input file

    with open(os.path.join(working_dir, result_name + '.inp'),'w') as output_file:
        for line in combined_lines:
            output_file.write(line)

def main():
    f_combineINP(inp_file='STARTER_SNL61p5_GFEM_adjst_S8R_2024-08-07_ML02_ID.inp',working_dir='../INPUT/')

if __name__ == '__main__':
    main()