from ccx2paraview import ccx2paraview
import os

def f_convertFRD2VTU(working_dir = '/.'):
    '''
    Converts all native CCX results in the .frd format
    in the current working directory to the .vtu format
    using ccx2paraview.

    Parameters:
    - None

    Returns:
    - None
    '''

    # get all frd files in the current directory
    current_dir = working_dir
    
    all_files = os.listdir(current_dir)
    all_frd_files = []

    for file in all_files:
        if file.endswith('.frd'):
            all_frd_files.append(file)

    # convert file with ccx2paraview
    for file in all_frd_files:
        c = ccx2paraview.Converter(os.path.join(current_dir, file), ['vtu'])
        c.run()

def main():
    f_convertFRD2VTU()

if __name__ == '__main__':
    main()
