import math

def read_file(inp_path):
    lines_in = open(inp_path).readlines()
    linewise = []
    for line in lines_in:
        if line[-1:] == '\n':
            linewise.append([line[:-1]])
        else:
            linewise.append([line])
   
    linewise_mod = []
    for line in linewise:
        if line != [''] or line != ['\n'] or line != ['\t']:
            linewise_mod.append(line)  

    return(linewise_mod)

    
def time_temp_input(linewise):
    time_lst = []
    temp_lst = []
    t_f__flag = 0
    mode_flag = 0
    tincr_flag = 0
    ot_info_inp = []
    
    for line in linewise:
        if line[0][0:2] != '**':
            if t_f__flag == 0:
                if line[0][0:6] == '*UNITS':
                    if line[0].split(',')[1].replace(' ', '') == 's': t_f = 1.0 
                    if line[0].split(',')[1].replace(' ', '') == 'min': t_f = 60.0 
                    if line[0].split(',')[1].replace(' ', '') == 'h': t_f = 3600.0
                    
                    t_f__flag += 1 

            if mode_flag == 0:
                if line[0][0:5] == '*MODE':
                    mode =  line[0].split(',')[1].replace(' ', '')

                    mode_flag += 1

            if tincr_flag == 0:
                if line[0][0:6] == '*TINCR':
                    tincr =  line[0].split(',')[1].replace(' ', '')
                    tincr = float(tincr)

                    tincr_flag += 1

            try: 
                testnum = float(line[0].split(',')[0][0])
                
                ot_info_inp.append(line)
         
                inp_lst = []
                for ent in line[0].split(','):
                    inp_lst.append(float(ent.replace(' ','')))

                time_hlp = [inp_lst[0]]
                temp_hlp = [inp_lst[1]]
                
                time_inc = inp_lst[0]
                for i in range(2, len(inp_lst)-1, 2):              
                    time_inc += inp_lst[i]
                    
                    time_hlp.append(time_inc * t_f)
                    temp_hlp.append(inp_lst[i+1])
                
                time_lst.append(time_hlp)
                temp_lst.append(temp_hlp)
            except ValueError:
                pass

    return(time_lst, temp_lst, t_f, mode, ot_info_inp, tincr)


def respar_transl(linewise):
    mat_param_dico = {}
    param_lst = []
    
    for line in linewise:
        if line[0][0:2] != '**':
            separ = line[0].split(',')
            mat_param_dico.update({separ[0].replace(' ',''): float(separ[1].replace(' ',''))})
            param_lst.append(separ[0].replace(' ',''))
    
    return(mat_param_dico, param_lst)


def msic_transl(linewise):
    line_count = 1

    i = 0
    
    msic_lst = []
    MAT_dico = {}
    stack_rvl_lst = []

    while i < len(linewise):
        if linewise[i][0][0:2] != '**':
            line = linewise[i][0]

            separ = line.split(',')

            if separ[0] == '*X_LST':
                X_lst = []
                for item in range(1, len(separ)):
                    X_lst.append(float(separ[item].strip()))

            if separ[0] == '*Y_LST':
                Y_lst = []
                for item in range(1, len(separ)):
                    Y_lst.append(float(separ[item].strip()))

            if separ[0] == '*Z_LST':
                Z_lst = []
                for item in range(1, len(separ)):
                    Z_lst.append(float(separ[item].strip()))

            if separ[0] == "*MAT":
                dico_lst = []
                for item in range (2, len(separ)):
                   
                    dico_lst.append(separ[item])
                MAT_dico.update({separ[1] : dico_lst})
                
            if separ[0] == '*YLINE':
                stack_lst = []

                j = i + 1

                while linewise[j][0][0] != '*': 
                    stack_lst_tmp = []
                    line_lst_tmp = []
                    tile_lst_tmp = []
                    
                    line = linewise[j][0]
                    line = line.replace(' ', '')
                    tile = line.split('#Z')

                    for layer in tile:
                        layer_lst_tmp = []
                        item = layer.split(',')
                        
                        for ite in item:
                            if ite != '':
                                try: layer_lst_tmp.append(float(ite))
                                except ValueError:
                                    layer_lst_tmp.append(ite)

                        tile_lst_tmp.append(layer_lst_tmp)

                        stack_rvl_lst.append(layer_lst_tmp)

                    stack_lst.append(tile_lst_tmp)
                    j += 1

                msic_lst.append(stack_lst)
                i = j    

        i += 1 

    return(X_lst, Y_lst, Z_lst, msic_lst, MAT_dico, stack_rvl_lst )


def msic_len_lst(lst):
    len_lst = []
    for i in range(0, len(lst)-1):
         
        len_lst.append(lst[i+1] - lst[i])
           
    return(len_lst)


def time_temp_lst(time_lst, temp_lst, t_incr):
    time_sum_lst = [time_lst[0]]
    temp_sum_lst = [temp_lst[0]]
    
    for pnt in range(0, len(time_lst)-1):
        delta_time = time_lst[pnt + 1] - time_lst[pnt]
        delta_temp = temp_lst[pnt + 1] - temp_lst[pnt]

        for i in range(0 + int(t_incr), int(delta_time + t_incr), int(t_incr)):
            time_sum_lst.append(i + time_lst[pnt])
            temp_sum_lst.append(temp_lst[pnt] + (delta_temp/delta_time) * i )

    return(time_sum_lst, temp_sum_lst)


def GeomHEX(V_f, r_f, num_x, num_y):
    num_x = int(num_x)
    num_y = int(num_y)

    a =  r_f * ( math.sqrt( ( math.pi * 2 )  / ( V_f * math.sqrt(3) ))  - 2)

    l_x = 0.5 * (2 * r_f + a )
    
    l_y = 0.5 * math.sqrt(3) * (2 * r_f + a )
    
    dx = l_x / num_x
    dy = l_y / num_y
    
    slx_lst = [dx / 2]
    for sl in range(1, num_x):
        slx_lst.append(slx_lst[sl-1] + dx)
    
    sly_lst = [dy / 2]
    for sl in range(1, num_y):
        sly_lst.append(sly_lst[sl-1] + dy)

    return(slx_lst, sly_lst, a, l_x, l_y, dx, dy )


def CalcFlen(SLX, SLY, a, l_x, l_y, r_f, dx, dy):
    yflen_lst  = []
    xflen_lst  = []

    for i in range(0, len(SLX)):
        flen_lo = 0.
        flen_hi = 0.
        
        if SLY[i] + dy/2 < r_f:
            flen_hi += math.sqrt( r_f**2 - ( SLY[i] + dy/2)**2)
        if SLY[i] - dy/2 < r_f:
            flen_lo += math.sqrt( r_f**2 - ( SLY[i] - dy/2)**2)
        
        if SLY[i] + dy/2 > l_y - r_f:
            flen_hi += math.sqrt( r_f**2 - ( r_f - ((SLY[i] + dy/2) - (l_y - r_f)) )**2)
        if SLY[i] - dy/2 > l_y - r_f:
            flen_lo += math.sqrt( r_f**2 - ( r_f - ((SLY[i] - dy/2) - (l_y - r_f)) )**2)
        
        yflen_lst.append((0.5 *(flen_lo + flen_hi)) / l_x )

        flen_lo = 0.
        flen_hi = 0.
        
        if SLX[i] + dx/2 < r_f:
            flen_hi += math.sqrt( r_f**2 - ( SLX[i] + dx/2)**2)
        if SLX[i] - dx/2 < r_f:
            flen_lo += math.sqrt( r_f**2 - ( SLX[i] - dx/2)**2)
            
        if SLX[i] + dx/2 > l_x - r_f:
            flen_hi += math.sqrt( r_f**2 - ( r_f - ((SLX[i] + dx/2) - (l_x - r_f)) )**2)
        if SLX[i] - dx/2 > l_x - r_f:
            flen_lo += math.sqrt( r_f**2 - ( r_f - ((SLX[i] + dx/2) - (l_x - r_f)) )**2)
            
        xflen_lst.append( (0.5 *(flen_lo + flen_hi)) / l_y)       

    f_m_lst  = []
    for i in range(0, len(SLX)):
        if math.sqrt(SLX[i]**2 + SLY[i]**2) < r_f or math.sqrt((SLX[i] - l_x)**2 + (SLY[i] - l_y)**2) < r_f:
            f_m_lst.append(0.)
        else:
            f_m_lst.append(1.)

    return(xflen_lst, yflen_lst, f_m_lst)