import math
from .FKT_LIB_CureKin import *

def ST_CLT_3D_STApp(mlst_tile, h_lst, h_tot):
    eff_prop_lst = []
    
    eff_prop_msic_lst = []

    A11 = 0.
    A22 = 0.
    A12 = 0.
    A66 = 0.

    for lay in range(0, len(mlst_tile)):
        mlst = mlst_tile[lay]

        h_lay = h_lst[lay]

        sin = math.sin(0. * math.pi / 180.)
        sin2 = math.sin(2 * 0. * math.pi / 180.)
        cos = math.cos(0. * math.pi / 180.)

        E1 = mlst[0]
        E2 = mlst[1]
        E3 = mlst[2] 
        NUE12 = mlst[3]
        NUE21 = E2 * NUE12/E1
        NUE13 = mlst[4]
        NUE23 = mlst[5] 
        G12 = mlst[6]
        G13 = mlst[7]
        G23 = mlst[8]

        Q11 = ( E1 /(1 - NUE12*NUE21))*cos**4 + (E2/( 1 - NUE12*NUE21 ))* sin**4 + 0.5 * sin2**2 * ( ( NUE12 * E2  )  / (1 - NUE12 * NUE21   ) + 2*G12 )
    
        Q22 = ( E1 /(1 - NUE12*NUE21))*sin**4 + (E2/( 1 - NUE12*NUE21 ))* cos**4 + 0.5 * sin2**2 * ( ( NUE12 * E2  )  / (1 - NUE12 * NUE21   ) + 2*G12 )
        
        Q66 = G12 + 0.25 * sin2**2 *( ( E1)/(1-NUE12 * NUE21) + ( E2)/(1-NUE12 * NUE21) - ( 2 * NUE12 *  E2)/(1-NUE12 * NUE21)  - 4*G12  )
        
        Q12 = (NUE12 * E2) /( 1 - NUE12 * NUE21  ) + 0.25 * sin2**2 *( ( E1)/(1-NUE12 * NUE21) + ( E2)/(1-NUE12 * NUE21) - ( 2 * NUE12 *  E2)/(1-NUE12 * NUE21)  - 4*G12 )

        A11 += Q11 * h_lst[lay] * h_tot
        
        A22 += Q22 * h_lst[lay] * h_tot
        
        A12 += Q12 * h_lst[lay] * h_tot
        
        A66 += Q66 * h_lst[lay] * h_tot

    E1_C = (A11 - (A12**2 /A22))/h_tot
    E2_C = (A22 - (A12**2 /A11))/h_tot
    G12_C = A66/h_tot
    NUE12_C = A12 / A22
    NUE21_C = NUE12_C * E2_C / E1_C

    NUE13_C = 0.
    NUE23_C = 0.
    G13_C = 0.
    G23_C = 0.

    for lay in range(0, len(mlst_tile)):

        h_lay = h_lst[lay]

        E1 = mlst[0]
        E2 = mlst[1]
        E3 = mlst[2]
        
        NUE12 = mlst[3]
        NUE21 = E2 * NUE12/E1
        NUE13 = mlst[4]
        NUE23 = mlst[5]
        
        G12 = mlst[6]
        G13 = mlst[7]
        G23 = mlst[8]

        sinSQ = (math.sin(0. * math.pi / 180.))**2
        
        cosSQ = (math.cos(0. * math.pi / 180.))**2
        
        NUE13_C += ( h_lay / ( 1- NUE12 * NUE21) ) * ( NUE13 * (cosSQ * ( 1 -NUE21 * NUE12_C)  + sinSQ * (NUE21 - NUE12_C)) +
                                                       NUE23 * (sinSQ * (1 - NUE12 * NUE12_C)  + cosSQ * (NUE12 - NUE12_C))  )
        
        NUE23_C += ( h_lay / ( 1- NUE12 * NUE21) ) * ( NUE13 * (sinSQ * ( 1 -NUE21 * NUE21_C)  + cosSQ * (NUE21 - NUE12_C)) +
                                                       NUE23 * (cosSQ * (1 - NUE12 * NUE21_C)  + sinSQ * (NUE12 - NUE21_C))  )
        
        G13_C += h_lay * (  cosSQ/ G13  + sinSQ / G23  )
        
        G23_C += ( h_lay * (  sinSQ/ G13  + cosSQ / G23  ))

    G13_C = 1 / G13_C
      
    G23_C = 1 / G23_C   

    E3_C = 0.

    for lay in range(0, len(mlst_tile)):

        h_lay = h_lst[lay]

        E1 = mlst[0]
        E2 = mlst[1]
        E3 = mlst[2]
        
        NUE12 = mlst[3]
        NUE21 = E2 * NUE12/E1
        NUE13 = mlst[4]
        NUE23 = mlst[5]
        
        G12 = mlst[6]
        G13 = mlst[7]
        G23 = mlst[8]

        sinSQ = (math.sin(0. * math.pi / 180.))**2

        cosSQ = (math.cos(0. * math.pi / 180.))**2

        E3_C += h_lay * (  1 / E3 - (NUE13**2)/E1 - (NUE23**2)/E2  + NUE13_C/E1_C * ( NUE13 * cosSQ + NUE23*sinSQ) + NUE23_C/E2_C * (NUE13 * sinSQ + NUE23* cosSQ) )
        
    E3_C = 1/E3_C 

    eff_prop_msic_lst.append([E1_C, E2_C, E3_C, NUE12_C, NUE13_C, NUE23_C, G12_C, G13_C, G23_C])

    return(eff_prop_msic_lst) 


if __name__ == '__main__': 
    ST_CLT_3D_STApp()