from .FKT_LIB_CureKin import *

def ST_FiberVR(work_dir, msic, PlainRes, Phi_F_g, f_lenZ ):
    
    Phi_F_global  = Phi_F_g / (f_lenZ)
   
    msic_file = msic.split('__')[0]

    inp_path = work_dir + msic + '.msic'

    linewise = read_file(inp_path)
   
    X_lst, Y_lst, prelim_Z_lst, msic_lst, MAT_dico, stack_rvl_lst = msic_transl(linewise)
    
    Z_lst = []
    for z in prelim_Z_lst:
        Z_lst.append(z * f_lenZ)
    
    #############################################################
    ###
    ### length list of mosaic tiles:
    
    lenX_lst = msic_len_lst(X_lst)
    lenY_lst = msic_len_lst(Y_lst)
    lenZ_lst = msic_len_lst(Z_lst)
    
    lay_num = -1
    
    Vol_tow = 0.
    Vol_res = 0.
    
    for lenY in lenY_lst:
        for lenX in lenX_lst:
            for lenZ in lenZ_lst:
                if lay_num < len(stack_rvl_lst) - 1: 
                    lay_num += 1
                    
                    if stack_rvl_lst[lay_num][0] == PlainRes:
                        Vol_res += lenX * lenY * lenZ
                        
                    elif stack_rvl_lst[lay_num][0] != PlainRes:
                        Vol_tow += lenX * lenY * lenZ
    TOTAL_V = max(X_lst) * max(Y_lst) * max(Z_lst)
    SUM_V = Vol_tow + Vol_res
   
    V_T = Vol_tow / TOTAL_V 
    V_R = 1 - V_T
    
    Phi_F_tow = Phi_F_global *(V_T + V_R) / V_T
    
    if Phi_F_tow >= 0.85: 
        Phi_F_tow = 0.85
    
    return(Phi_F_tow, V_T, V_R, X_lst[-1], Y_lst[-1], Z_lst[-1])
    

if __name__ == '__main__':
    ST_FiberVR()