import math
from .FKT_LIB_CureKin import *

def ST_HoGeneS_STApp(dir_dyn, dir_sta, mat_param_dico, param_lst, fin_dico, msic, f_lenZ ): 
    inp_path = dir_sta + msic
    read_file(inp_path)
    
    linewise = read_file(inp_path)
   
    X_lst, Y_lst, prelim_Z_lst, msic_lst, MAT_dico, stack_rvl_lst = msic_transl(linewise)
    
    Z_lst = []
    for z in prelim_Z_lst:
        Z_lst.append(z * f_lenZ)

    mat_dico = {
        'TOW': 
        [
            fin_dico['CH_E11'], fin_dico['CH_E22'], fin_dico['CH_E22'], fin_dico['CH_NUE12'], fin_dico['CH_NUE12'],
            fin_dico['CH_NUE23'], fin_dico['CH_G12'] , fin_dico['CH_G12'] , fin_dico['CH_G23']
        ],
        'PURERESIN': 
        [
            fin_dico['E_r'], fin_dico['E_r'], fin_dico['E_r'], fin_dico['nue_r'], fin_dico['nue_r'],
            fin_dico['nue_r'], fin_dico['E_r'] / ( 2* ( fin_dico['nue_r'] + 1)),
            fin_dico['E_r'] / ( 2* ( fin_dico['nue_r'] + 1)), fin_dico['E_r'] / ( 2* ( fin_dico['nue_r'] + 1)) ]
        }

    Dx_lst = []
    Dy_lst = []
    Dz_lst = []

    for i in range(1, len(X_lst)):        
        Dx_lst.append( ( X_lst[i] - X_lst[i-1] ) / X_lst[-1] )
        
    for i in range(1, len(Y_lst)):        
        Dy_lst.append( ( Y_lst[i] - Y_lst[i-1] ) / Y_lst[-1] )
        
    for i in range(1, len(Z_lst)):        
        Dz_lst.append( ( Z_lst[i] - Z_lst[i-1] ) / Z_lst[-1] )
    
    eff_prop_lst = []
    eff_strain_lst = []
    eff_vol_lst = []
    
    for x_row in msic_lst:
        eff_prop_msic_lst = []
        eff_strain_msic_lst = []
        eff_vol_msic_lst = []
        
        for msic in x_row:   
            h_lst = Dz_lst
            h_tot = Z_lst[-1]
            
            A11 = 0.
            A22 = 0.
            A12 = 0.
            A66 = 0.
            
            for lay in range(0, len(msic)):          
                thet = msic[lay][1]
                mat_name = msic[lay][0]
                
                mlst = mat_dico[mat_name]
                sin = math.sin(msic[lay][1] * math.pi / 180.)
                sin2 = math.sin(2 * msic[lay][1] * math.pi / 180.)
                cos = math.cos(msic[lay][1] * math.pi / 180.)

                E1 = mlst[0]
                E2 = mlst[1]

                NUE12 = mlst[3]
                NUE21 = E2 * NUE12/E1

                G12 = mlst[6]

                Q11 = ( E1 /(1 - NUE12*NUE21))*cos**4 + (E2/( 1 - NUE12*NUE21 ))* sin**4 + 0.5 * sin2**2 * ( ( NUE12 * E2  )  / (1 - NUE12 * NUE21   ) + 2*G12 )
            
                Q22 = ( E1 /(1 - NUE12*NUE21))*sin**4 + (E2/( 1 - NUE12*NUE21 ))* cos**4 + 0.5 * sin2**2 * ( ( NUE12 * E2  )  / (1 - NUE12 * NUE21   ) + 2*G12 )
                
                Q66 = G12 + 0.25 * sin2**2 *( ( E1)/(1-NUE12 * NUE21) + ( E2)/(1-NUE12 * NUE21) - ( 2 * NUE12 *  E2)/(1-NUE12 * NUE21)  - 4*G12  )
                
                Q12 = (NUE12 * E2) /( 1 - NUE12 * NUE21  ) + 0.25 * sin2**2 *( ( E1)/(1-NUE12 * NUE21) + ( E2)/(1-NUE12 * NUE21) - ( 2 * NUE12 *  E2)/(1-NUE12 * NUE21)  - 4*G12 )

                A11 += Q11 * h_lst[lay] * h_tot
                
                A22 += Q22 * h_lst[lay] * h_tot
                
                A12 += Q12 * h_lst[lay] * h_tot
                
                A66 += Q66 * h_lst[lay] * h_tot
                
            E1_C = (A11 - (A12**2 /A22))/h_tot
            E2_C = (A22 - (A12**2 /A11))/h_tot
            G12_C = A66/h_tot
            NUE12_C = A12 / A22
            NUE21_C = NUE12_C * E2_C / E1_C

            NUE13_C = 0.
            NUE23_C = 0.
            G13_C = 0.
            G23_C = 0.
            
            h_lst = Dz_lst
            
            for lay in range(0, len(msic)):
                thet = msic[lay][1]
                mat_name = msic[lay][0]
                h_lay = h_lst[lay]
                mlst = mat_dico[mat_name]

                E1 = mlst[0]
                E2 = mlst[1]
                E3 = mlst[2]

                NUE12 = mlst[3]
                NUE21 = E2 * NUE12/E1
                NUE13 = mlst[4]
                NUE23 = mlst[5]

                G12 = mlst[6]
                G13 = mlst[7]
                G23 = mlst[8]

                sinSQ = (math.sin(msic[lay][1] * math.pi / 180.))**2

                cosSQ = (math.cos(msic[lay][1] * math.pi / 180.))**2

                NUE13_C += ( h_lay / ( 1- NUE12 * NUE21) ) * ( NUE13 * (cosSQ * ( 1 -NUE21 * NUE12_C)  + sinSQ * (NUE21 - NUE12_C)) +
                                                               NUE23 * (sinSQ * (1 - NUE12 * NUE12_C)  + cosSQ * (NUE12 - NUE12_C))  )
                
                NUE23_C += ( h_lay / ( 1- NUE12 * NUE21) ) * ( NUE13 * (sinSQ * ( 1 -NUE21 * NUE21_C)  + cosSQ * (NUE21 - NUE12_C)) +
                                                               NUE23 * (cosSQ * (1 - NUE12 * NUE21_C)  + sinSQ * (NUE12 - NUE21_C))  )

                G13_C += h_lay * (  cosSQ/ G13  + sinSQ / G23  )

                G23_C += ( h_lay * (  sinSQ/ G13  + cosSQ / G23  ))

            G13_C = 1 / G13_C
              
            G23_C = 1 / G23_C   

            E3_C = 0.

            h_lst = Dz_lst

            for lay in range(0, len(msic)):
                thet = msic[lay][1]
                mat_name = msic[lay][0]
                h_lay = h_lst[lay]
                mlst = mat_dico[mat_name]

                E1 = mlst[0]
                E2 = mlst[1]
                E3 = mlst[2]

                NUE12 = mlst[3]
                NUE21 = E2 * NUE12/E1
                NUE13 = mlst[4]
                NUE23 = mlst[5]
                
                G12 = mlst[6]
                G13 = mlst[7]
                G23 = mlst[8]
                
                sinSQ = (math.sin(msic[lay][1] * math.pi / 180.))**2
                
                cosSQ = (math.cos(msic[lay][1] * math.pi / 180.))**2
                
                E3_C += h_lay * (  1 / E3 - (NUE13**2)/E1 - (NUE23**2)/E2  + NUE13_C/E1_C * ( NUE13 * cosSQ + NUE23*sinSQ) + NUE23_C/E2_C * (NUE13 * sinSQ + NUE23* cosSQ) )
                
            E3_C = 1/E3_C 
            
            eff_prop_msic_lst.append([E1_C, E2_C, E3_C, NUE12_C, NUE13_C, NUE23_C, G12_C, G13_C, G23_C])
             
        eff_prop_lst.append(eff_prop_msic_lst)    
                 
    return(eff_prop_lst, X_lst, Y_lst, Z_lst, msic_lst)            
            

if __name__ == '__main__':     
    ST_HoGeneS_STApp()